// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: connectrpc/guesses/v1/events.proto

package guessesv1connect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v1 "gitlab.com/binarygame/microservices/guesses/pkg/gen/connectrpc/guesses/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// EventServiceName is the fully-qualified name of the EventService service.
	EventServiceName = "connectrpc.guesses.v1.EventService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// EventServiceSubscribeGuessesEventsProcedure is the fully-qualified name of the EventService's
	// SubscribeGuessesEvents RPC.
	EventServiceSubscribeGuessesEventsProcedure = "/connectrpc.guesses.v1.EventService/SubscribeGuessesEvents"
	// EventServiceSubscribeAllGuessesEventsProcedure is the fully-qualified name of the EventService's
	// SubscribeAllGuessesEvents RPC.
	EventServiceSubscribeAllGuessesEventsProcedure = "/connectrpc.guesses.v1.EventService/SubscribeAllGuessesEvents"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	eventServiceServiceDescriptor                         = v1.File_connectrpc_guesses_v1_events_proto.Services().ByName("EventService")
	eventServiceSubscribeGuessesEventsMethodDescriptor    = eventServiceServiceDescriptor.Methods().ByName("SubscribeGuessesEvents")
	eventServiceSubscribeAllGuessesEventsMethodDescriptor = eventServiceServiceDescriptor.Methods().ByName("SubscribeAllGuessesEvents")
)

// EventServiceClient is a client for the connectrpc.guesses.v1.EventService service.
type EventServiceClient interface {
	// RPC to get a stream of GuessEvents based on the roomId
	SubscribeGuessesEvents(context.Context, *connect.Request[v1.SubscribeGuessesEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeGuessesEventsResponse], error)
	// RPC to get a stream of GuessEvents of all rooms
	SubscribeAllGuessesEvents(context.Context, *connect.Request[v1.SubscribeAllGuessesEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeAllGuessesEventsResponse], error)
}

// NewEventServiceClient constructs a client for the connectrpc.guesses.v1.EventService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewEventServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) EventServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &eventServiceClient{
		subscribeGuessesEvents: connect.NewClient[v1.SubscribeGuessesEventsRequest, v1.SubscribeGuessesEventsResponse](
			httpClient,
			baseURL+EventServiceSubscribeGuessesEventsProcedure,
			connect.WithSchema(eventServiceSubscribeGuessesEventsMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		subscribeAllGuessesEvents: connect.NewClient[v1.SubscribeAllGuessesEventsRequest, v1.SubscribeAllGuessesEventsResponse](
			httpClient,
			baseURL+EventServiceSubscribeAllGuessesEventsProcedure,
			connect.WithSchema(eventServiceSubscribeAllGuessesEventsMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// eventServiceClient implements EventServiceClient.
type eventServiceClient struct {
	subscribeGuessesEvents    *connect.Client[v1.SubscribeGuessesEventsRequest, v1.SubscribeGuessesEventsResponse]
	subscribeAllGuessesEvents *connect.Client[v1.SubscribeAllGuessesEventsRequest, v1.SubscribeAllGuessesEventsResponse]
}

// SubscribeGuessesEvents calls connectrpc.guesses.v1.EventService.SubscribeGuessesEvents.
func (c *eventServiceClient) SubscribeGuessesEvents(ctx context.Context, req *connect.Request[v1.SubscribeGuessesEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeGuessesEventsResponse], error) {
	return c.subscribeGuessesEvents.CallServerStream(ctx, req)
}

// SubscribeAllGuessesEvents calls connectrpc.guesses.v1.EventService.SubscribeAllGuessesEvents.
func (c *eventServiceClient) SubscribeAllGuessesEvents(ctx context.Context, req *connect.Request[v1.SubscribeAllGuessesEventsRequest]) (*connect.ServerStreamForClient[v1.SubscribeAllGuessesEventsResponse], error) {
	return c.subscribeAllGuessesEvents.CallServerStream(ctx, req)
}

// EventServiceHandler is an implementation of the connectrpc.guesses.v1.EventService service.
type EventServiceHandler interface {
	// RPC to get a stream of GuessEvents based on the roomId
	SubscribeGuessesEvents(context.Context, *connect.Request[v1.SubscribeGuessesEventsRequest], *connect.ServerStream[v1.SubscribeGuessesEventsResponse]) error
	// RPC to get a stream of GuessEvents of all rooms
	SubscribeAllGuessesEvents(context.Context, *connect.Request[v1.SubscribeAllGuessesEventsRequest], *connect.ServerStream[v1.SubscribeAllGuessesEventsResponse]) error
}

// NewEventServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewEventServiceHandler(svc EventServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	eventServiceSubscribeGuessesEventsHandler := connect.NewServerStreamHandler(
		EventServiceSubscribeGuessesEventsProcedure,
		svc.SubscribeGuessesEvents,
		connect.WithSchema(eventServiceSubscribeGuessesEventsMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	eventServiceSubscribeAllGuessesEventsHandler := connect.NewServerStreamHandler(
		EventServiceSubscribeAllGuessesEventsProcedure,
		svc.SubscribeAllGuessesEvents,
		connect.WithSchema(eventServiceSubscribeAllGuessesEventsMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/connectrpc.guesses.v1.EventService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case EventServiceSubscribeGuessesEventsProcedure:
			eventServiceSubscribeGuessesEventsHandler.ServeHTTP(w, r)
		case EventServiceSubscribeAllGuessesEventsProcedure:
			eventServiceSubscribeAllGuessesEventsHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedEventServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedEventServiceHandler struct{}

func (UnimplementedEventServiceHandler) SubscribeGuessesEvents(context.Context, *connect.Request[v1.SubscribeGuessesEventsRequest], *connect.ServerStream[v1.SubscribeGuessesEventsResponse]) error {
	return connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.guesses.v1.EventService.SubscribeGuessesEvents is not implemented"))
}

func (UnimplementedEventServiceHandler) SubscribeAllGuessesEvents(context.Context, *connect.Request[v1.SubscribeAllGuessesEventsRequest], *connect.ServerStream[v1.SubscribeAllGuessesEventsResponse]) error {
	return connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.guesses.v1.EventService.SubscribeAllGuessesEvents is not implemented"))
}
